//
//  MINTLKeyBindingManager.swift
//  MenuTester
//
//  Created by narita on 2017/07/30.
//  Copyright © 2017年 narita. All rights reserved.
//

import Cocoa

class MINTLKeyBindingManager: NSObject
{

    // MARK: - class methods
    static let sharedInstance = MINTLKeyBindingManager()
        

    
    // MARK: - init methods
    private override init()
    {
        super.init()
        
    }

    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods
    
    
    // MARK: - event handling methods
    func keySwitching(with event: NSEvent, target: NSResponder) -> Bool
    {
        
        
        // ⌘Eの時はこちらで処理する
        if( self.isPerformKeyswitch(with:event, target:target) )
        {
            // 帰値は、(1) 上位オブジェクトのコマンドを処理の可否のフラグの返却
            // MINTLの中で[target doCommandBySelector:];
            //             target.doCommand(by: theSelector) // <-- このメソッドはTextInputProtocolからなので、NSResponderに代用品を書いておく事。

            __NSBeep();
            
            return true;
        }
        
        

        
        return false
    }

    // NSResponderからのメソッド
    func performKeySwitching(with event: NSEvent, target: NSResponder) -> Bool
    {
        return self.isPerformKeyswitch(with:event, target:target)
    }

    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)
    
    // MARK: - Utility methods
    
    
    func isPerformKeyswitch(with event: NSEvent, target: NSResponder) -> Bool
    {
        if(
            event.modifierFlags.contains(.command)
                &&
            event.charactersIgnoringModifiers == "E"
        )
        {
            return true
        }
        else
        {
            return false
        }
    }

}
