//
//  MINTLTextView.swift
//  MenuTester
//
//  Created by narita on 2017/07/30.
//  Copyright © 2017年 narita. All rights reserved.
//

import Cocoa

class MINTLTextView: NSTextView
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods
    
    @IBAction func showSwitchboard(_ sender:AnyObject)
    {
        // ここで、次のコマンドのPanelを表示する
        __NSBeep()
    }
    
    // MARK: - event handling methods
    
    override func keyDown(with event: NSEvent)
    {
        if(
            self.hasMarkedText() == false && // TextInputの変換中でない事。
            event.charactersIgnoringModifiers != nil) // modifierキーだけのKeyDownでない事。
        {
            if( MINTLKeyBindingManager.sharedInstance.keySwitching(with: event, target: self) )
            {
                return
            }
        }
        
        super.keyDown(with: event)
    }
    
    
    override func performKeyEquivalent(with event: NSEvent) -> Bool
    {
        return MINTLKeyBindingManager.sharedInstance.performKeySwitching(with: event, target: self)
    }

    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)
    
    // MARK: - Utility methods
    
    override func validateUserInterfaceItem(_ item: NSValidatedUserInterfaceItem) -> Bool
    {
        return respondsAndPerformValidatedUserInterface(item)
        {
            super.validateUserInterfaceItem($0)
        }

//        var theResult:Bool = true
//        
//        self.respondsAndPerformAnyUtility(item)
//        
//        if( self.responds(toCanSelector:item.action) )
//        {
//            theResult =  self.performCanAction(item)
//        }
//        else
//        {
//            theResult = super.validateUserInterfaceItem(item)
//        }
//        
//        return theResult
    }
}
