//
//  TAViewController.swift
//  TravelAdvisor
//
//  Created by narita on 2017/08/29.
//  Copyright © 2017年 narita. All rights reserved.
//

import Cocoa

class TAViewController: MINTLViewController
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    override func viewDidLoad()
    {
        super.viewDidLoad()
        
        // Do any additional setup after loading the view.
    }
    
    // MARK: - action methods
    
    @IBAction func newCountry(_ sender: NSObject!)
    {
        self.countriesController!.add(nil)
    }
    
    @objc func canNewCountry(_ sender: NSObject!) -> Bool
    {
        return self.countriesController!.canAdd
    }
    
    @IBAction func removeCountry(_ sender: NSObject!)
    {
        self.countriesController!.remove(nil)
    }
    
    @objc func canRemoveCountry(_ sender: NSObject!) -> Bool
    {
        return self.countriesController!.canRemove
    }
    
    @IBAction func clearCountry(_ sender: NSObject!)
    {
        // めんどくさくなったので、未実装
        print("\(String(describing: self.countriesController))")
        print("\(String(describing: self.representedObject))")
    }
    
    @objc func canClearCountry(_ sender: NSObject!) -> Bool
    {
        return true
    }
    
    
    @IBAction func selectNext(_ sender: NSObject!)
    {
        self.countriesController!.selectNext(sender)
    }
    
    @objc func canSelectNext(_ sender: NSObject!) -> Bool
    {
        return self.countriesController!.canSelectNext
    }
    
    @IBAction func selectPrevious(_ sender: NSObject!)
    {
        self.countriesController!.selectPrevious(sender)
    }
    
    @objc func canSelectPrevious(_ sender: NSObject!) -> Bool
    {
        return self.countriesController!.canSelectPrevious
    }
    
    @IBAction func convertCurrency(_ sender: NSObject!)
    {
        if let theManagedObject = countriesController?.value(forKeyPath: "selection") as? NSManagedObject?
        {
            currencyLoclaField?.floatValue = (currencyDollarsField?.floatValue)! * (theManagedObject!.currencyRate?.floatValue)!
        }
    }
    
    @objc func canConvertCurrency(_ sender: NSObject!) -> Bool
    {
        return countriesController?.selectedObjects!.count != 0
    }
    
    @IBAction func convertTemp(_ sender: NSObject!)
    {
        self.fahrenheitField!.floatValue = (((9.0/5.0) * celsiusField!.floatValue) + 32.0)
    }
    
    @objc func canConvertTemp(_ sender: NSObject!) -> Bool
    {
        return true
    }
    
    // MARK: - event handling methods
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)
    
    @IBOutlet var countriesController:  NSArrayController?
    
    @IBOutlet var currencyDollarsField: NSTextField?
    @IBOutlet var currencyLoclaField:   NSTextField?
    
    @IBOutlet var fahrenheitField:      NSTextField?
    @IBOutlet var celsiusField:         NSTextField?
    
    override var representedObject: Any?
    {
        didSet
        {
            // Update the view, if already loaded.
        }
    }
}

