//
//  MINTLPreferencesTabViewController.swift
//  MenuTester
//
//  Created by narita on 2017/08/03.
//  Copyright © 2017年 narita. All rights reserved.
//

import Cocoa

class MINTLPreferencesTabViewController: NSTabViewController
{
    // MARK: - class methods
    
    // MARK: - init methods

    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    class override var restorableStateKeyPaths: [String]
    {
        get
        {
            let r = super.restorableStateKeyPaths
        
            return r + ["selectedTabViewItemIndex"]
        }
    }

    // MARK: - life cycle methods
    
    override func viewDidLoad()
    {
        super.viewDidLoad()

        // あらかじめTabViewに関する"制約"を保存しておく。
        // 保存しておかないと、後で制約をディアクティブにすると取れなくなってしまう。
        self.tabVewConstraints = self.view.constraints
    }

    // MARK: - action methods
    
    // MARK: - event handling methods
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    override func tabView(_ tabView: NSTabView, willSelect tabViewItem: NSTabViewItem?)
    {
        self.tabVewConstraints = self.view.constraints
        // 保存していた制約を全部OFF
        self.tabVewConstraints.forEach{$0.isActive = false}
        
        super.tabView(tabView, willSelect:tabViewItem)
    }
    
    override func tabView(_ tabView: NSTabView, didSelect tabViewItem: NSTabViewItem?)
    {
        // Tabの切り替えが終わったら、保存していた制約を全部ONにしてアニメーションさせる。
        super.tabView(tabView, didSelect: tabViewItem)
        
        tabViewItem!.view!.alphaValue = 0.0
        
        NSAnimationContext.runAnimationGroup(
            {
                context in
                
                context.duration = 0.2
                context.allowsImplicitAnimation = true
                
                self.tabVewConstraints.forEach{$0.isActive = true}

                tabView.window?.layoutIfNeeded()
                
                self.view.window?.title = tabViewItem!.label
            },
            completionHandler:
            {
                NSAnimationContext.current.duration = 0.2
                tabViewItem!.view!.animator().alphaValue = 1.0
            }
        )
    }

    // MARK: - accessor methods (in pairs)
    
    private var tabVewConstraints: [NSLayoutConstraint] = [] // 制約の保存用
    
    // MARK: - Utility methods

    
}
